<template>
  <v-container>
    <v-row>
      <v-col cols="3"> </v-col>
      <v-col cols="8" offset="1">
        <h1 class="page-header">
          Резюме <span class="header-info ">{{ cvs.length }}</span>
        </h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="3">
        <accordion class="sort-list">
          <div slot="heading">
            <div class="sort-list-heading">
              {{ selectedVacancy }}
            </div>
          </div>
          <div>
            <div
              class="sort-list-item"
              v-for="vacancy in this.vacancys"
              :key="`filter-${vacancy.id}`"
              @click="selectVacancy(vacancy.name)"
            >
              {{ vacancy.name }}
            </div>
          </div>
        </accordion>
        <accordion
          class="sort-list"
          v-for="(filter, index) in filters"
          :key="`filter-${index}`"
        >
          <div slot="heading">
            <div class="sort-list-heading">
              {{ filter.title }}
              <span class="sort-list-count">{{ filter.count }}</span>
            </div>
          </div>
          <div>
            <div
              class="sort-list-item"
              v-for="(item, i) in filter.items"
              :key="`filter-row-${index}-${i}`"
            >
              {{ item.title }}
              <span class="sort-list-count">{{ item.count }}</span>
            </div>
          </div>
        </accordion>
      </v-col>
      <v-col cols="8" offset="1">
        <v-row>
          <v-col
            cols="6"
            v-for="(item, index) in cvs"
            :key="`cv-item-${item.id}`"
          >
            <cv-item :index="index" :cv="item" />
          </v-col>
        </v-row>
      </v-col>
    </v-row>
  </v-container>
</template>
<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { Cv } from "../../models/cv";
import Accordion from "@/components/ui/Accordion.vue";
import CvItem from "./CvItem.vue";
import { Vacancy } from "../../models/vacancy";

@Component({
  components: {
    Accordion,
    CvItem,
  },
})
export default class CvList extends Vue {
  cvs: Array<Cv> = [];
  vacancys: Array<Vacancy> = [];
  selectedVacancy = "Не выбрана вакансия";

  filters = [
    {
      title: "Все направления",
      count: "2",
      items: [
        { title: "Front-end", count: "2" },
        { title: "Back-end", count: "2" },
        { title: "Все направления", count: "2" },
      ],
    },
    {
      title: "Все технологии",
      count: "2",
      items: [
        { title: "JavaScript", count: "2" },
        { title: "Python", count: "2" },
        { title: "Vue.js", count: "2" },
        { title: "AngularJS", count: "2" },
        { title: "Все технологии", count: "2" },
      ],
    },
  ];

  async mounted() {
    this.vacancys = await Vacancy.getList();
    this.cvs = await Cv.getList();
  }

  selectVacancy(val: string) {
    this.selectedVacancy = val;
    this.cvs.sort(() => Math.random() - 0.5);
  }
}
</script>

<style>
.sort-list-item {
  cursor: pointer;
}
</style>
